<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_FareGroupPrice ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_FareGroupPrice extends AbstractStructArrayBase
{
    /**
     * The FareGroupPrice
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_FareGroupPrice[]
     */
    public $FareGroupPrice;
    /**
     * Constructor method for ArrayOfJP_FareGroupPrice
     * @uses ArrayOfJP_FareGroupPrice::setFareGroupPrice()
     * @param \StructType\JP_FareGroupPrice[] $fareGroupPrice
     */
    public function __construct(array $fareGroupPrice = array())
    {
        $this
            ->setFareGroupPrice($fareGroupPrice);
    }
    /**
     * Get FareGroupPrice value
     * @return \StructType\JP_FareGroupPrice[]|null
     */
    public function getFareGroupPrice()
    {
        return $this->FareGroupPrice;
    }
    /**
     * This method is responsible for validating the values passed to the setFareGroupPrice method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFareGroupPrice method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFareGroupPriceForArrayConstraintsFromSetFareGroupPrice(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_FareGroupPriceFareGroupPriceItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_FareGroupPriceFareGroupPriceItem instanceof \StructType\JP_FareGroupPrice) {
                $invalidValues[] = is_object($arrayOfJP_FareGroupPriceFareGroupPriceItem) ? get_class($arrayOfJP_FareGroupPriceFareGroupPriceItem) : sprintf('%s(%s)', gettype($arrayOfJP_FareGroupPriceFareGroupPriceItem), var_export($arrayOfJP_FareGroupPriceFareGroupPriceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FareGroupPrice property can only contain items of type \StructType\JP_FareGroupPrice, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FareGroupPrice value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FareGroupPrice[] $fareGroupPrice
     * @return \ArrayType\ArrayOfJP_FareGroupPrice
     */
    public function setFareGroupPrice(array $fareGroupPrice = array())
    {
        // validation for constraint: array
        if ('' !== ($fareGroupPriceArrayErrorMessage = self::validateFareGroupPriceForArrayConstraintsFromSetFareGroupPrice($fareGroupPrice))) {
            throw new \InvalidArgumentException($fareGroupPriceArrayErrorMessage, __LINE__);
        }
        $this->FareGroupPrice = $fareGroupPrice;
        return $this;
    }
    /**
     * Add item to FareGroupPrice value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FareGroupPrice $item
     * @return \ArrayType\ArrayOfJP_FareGroupPrice
     */
    public function addToFareGroupPrice(\StructType\JP_FareGroupPrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_FareGroupPrice) {
            throw new \InvalidArgumentException(sprintf('The FareGroupPrice property can only contain items of type \StructType\JP_FareGroupPrice, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FareGroupPrice[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_FareGroupPrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_FareGroupPrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_FareGroupPrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_FareGroupPrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_FareGroupPrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareGroupPrice
     */
    public function getAttributeName()
    {
        return 'FareGroupPrice';
    }
}
